<?php
/*******************************************************************************\
* 	Filename: stream_wrapper.php												*
*	 Last Revision: 7/30/07 10:12 PM EDT by Drakkim								*
*																	*
*	 Goals:															*
*		Create phpBB3 wrapper without using iFrames.								*
*																	*
*	 To Do:															*
*	X	Create a container for phpBB3 where everything evaluates as if it were another page		*
* 	X	Pass cookies and session stuff through the wrapper.								*
*	X	Process phpBB3's output to make desired changes (change links, etc.)					*
*	X	Display the container												*
*																	*
*	Problems:															*
*		Since the server is doing all the phpBB requests, the 'users IP' is always the web server's		*
*		This means you have to disable IP checking for the board to work at all. AND you can't		*
*		track IPs in the forum. Definite security issues.... 								*
*																	*
\******************************************************************************/

class stream_wrapper {

	function displayWrap( &$row, &$params, &$menu ) {

		require ('stream_vars.php');
		
// Open a connection to the board
		$phpbb_stream = stream_socket_client('tcp://'.$phpbb_site.':80', $errno, $errstr, 30);
		if (!$phpbb_stream) {
			echo "$errstr ($errno)<br />\n";
		} else {
// Send a request for the page... need to send more information

// Put the cookies in the jar
$cookie_jar = "";
foreach($_COOKIE as $key => $value) {
	if ($cookie_jar != "") {
		$cookie_jar .= '; ';
	}
	$cookie_jar .= $key .'='. $value;
}

// Repeat most of the browser's request to the forum
$req_headers =
"GET $url HTTP/1.0\r\n"
."Host: $phpbb_site\r\nUser-Agent: ". $_SERVER['HTTP_USER_AGENT'].
"\r\nAccept: */*\r\nAccept-Language: " . $_SERVER['HTTP_ACCEPT_LANGUAGE'].
"\r\nAccept-Charset: "	. $_SERVER['HTTP_ACCEPT_CHARSET']. //ISO-8859-1,utf-8;q=0.7,*;q=0.7".
"\r\nKeep-Alive: 300". // Should this one be sent??
"\r\nConnection: ". $_SERVER['HTTP_CONNECTION'].
"\r\nX-Forwarded-For: ". $_SERVER['REMOTE_ADDR'].
"\r\nCookie: ". $cookie_jar .
"\r\nCache-Control: max-age=0\r\n\r\n";


		    fwrite($phpbb_stream, $req_headers);
// Dump the page into a string
		    while (!feof($phpbb_stream)) {
		        $phpbb_string = $phpbb_string . fgets($phpbb_stream, 1024);
		    }
// Close the "file"
		    fclose($phpbb_stream);

// Separate the headers from the page
			$header_length = strpos($phpbb_string, 'UTF-8') + 7;
			$headers_string = substr($phpbb_string, 0, $header_length);
			$phpbb_string = substr($phpbb_string, $header_length);

// Send the headers
			$headers_array = explode("\r\n", $headers_string);
			foreach ($headers_array as $value) {
				header($value);
			}

// Replace whatever we need to
			foreach ($replacements as $value) {
				$phpbb_string = str_replace ($value[0], $value[1] , $phpbb_string);
			}
// Output the processed page
			// echo '<div class="phpbb">';
			echo '<table width="100%" align="center"><tr><td class="phpbb">';
//			echo 'Request sent:<br>' . str_replace ("\r\n",'<br>',$req_headers);
//			echo 'Headers recieved:<br>' . str_replace ("\r\n",'<br>',$headers_string);
			echo $phpbb_string;
			echo '</td></tr></table>';
			// echo '</div>';
		}
	}
}

?>